From 01feafd7251868f3405122e38940d9d90b73a256 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Apr 16 2015 17:51:51 +0000
Subject: [PATCH 5/254] Wrap up argument propagation in a @wraps decorator.


---

diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 69715c8..88f750f 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -1,14 +1,24 @@
 import collections
+import functools
+
 
 Argument = collections.namedtuple('Argument', ('name', 'default', 'help'))
 
 
 def argument(name, default, help):
     def decorator(func):
+        @wraps(func)
         def inner(*args, **kwargs):
             return func(*args, **kwargs)
 
-        inner.widget_arguments = getattr(func, 'widget_arguments', [])
         inner.widget_arguments.append(Argument(name, default, help))
         return inner
     return decorator
+
+def wraps(original):
+    @functools.wraps(original)
+    def decorator(subsequent):
+        subsequent = functools.wraps(original)(subsequent)
+        subsequent.widget_arguments = getattr(original, 'widget_arguments', [])
+        return subsequent
+    return decorator
diff --git a/hubs/widgets/chrome.py b/hubs/widgets/chrome.py
index afc3e0d..7862e49 100644
--- a/hubs/widgets/chrome.py
+++ b/hubs/widgets/chrome.py
@@ -1,3 +1,4 @@
+from base import wraps
 
 _panel_template = """
 <div class="panel panel-default">
@@ -16,15 +17,15 @@ _panel_heading_template = """
   </div> <!-- end panel-heading -->
 """
 
+
 def panel(title=None):
     def decorator(func):
+        @wraps(func)
         def inner(*args, **kwargs):
             heading = ''
             if title:
                 heading = _panel_heading_template.format(title=title)
             content = func(*args, **kwargs)
             return _panel_template.format(content=content, heading=heading)
-
-        inner.widget_arguments = getattr(func, 'widget_arguments', [])
         return inner
     return decorator

